//
//  Mesure de tension
//
//
// Auteur : www.thyzoon.fr 
//
// 2011-2019
//

//  ^
// /!\	 Version spécifique pour gestion de 3 accus LiPo 2S
// ---

#include "Tension_Lipo.h"

TensionLipo::TensionLipo() {
}

void TensionLipo::begin(){
   analogReference(DEFAULT); // reference alim. 5V
   digitalWrite(A0, LOW); 
   pinMode(A0, INPUT);
   digitalWrite(A1, LOW); 
   pinMode(A1, INPUT);
   digitalWrite(A2, LOW); 
   pinMode(A2, INPUT); 
}

float TensionLipo::Tension_Lipo1 (){
  static float MV1 = 0.0; 					
  static float MV2 = 0.0;
  float MV3;
  float val;
  
  MV3 =  mesure(A0)* COEF_LIPO1;
  val = (MV1 + MV2 + MV3) / 3; // filtrage (moyenne de 3 echantillons)
  MV1 = MV2; // décalage
  MV2 = MV3;
  
  return val;
}

float TensionLipo::Tension_Lipo2 (){
  static float MV1 = 0.0;
  static float MV2 = 0.0;
  float MV3;
  float val;
  
  MV3 =  mesure(A1)* COEF_LIPO2;
  val = (MV1 + MV2 + MV3) / 3; // filtrage (moyenne de 3 echantillons)
  MV1 = MV2; // décalage
  MV2 = MV3;
  
  return val;  
}

float TensionLipo::Tension_Lipo3 (){
  static float MV1 = 0.0;
  static float MV2 = 0.0;
  float MV3;
  float val;
  
  MV3 =  mesure(A2)* COEF_LIPO3;
  val = (MV1 + MV2 + MV3) / 3; // filtrage (moyenne de 3 echantillons)
  MV1 = MV2; // décalage
  MV2 = MV3;
  
  return val;  
}

// Mesure tension (CAN)
uint16_t TensionLipo::mesure(uint8_t pin){
  uint16_t val = analogRead(pin); 
  return val;
}


